var glob  = require('glob');
var async = require('async');
var fs    = require('fs');
var jsdoc2md = require("jsdoc-to-markdown");
var count = 0;

exports.workMagic = function (path) {

    glob(path, function (error, files) {

        async.eachSeries(files, function (file, next) {

            var doc = jsdoc2md.render(file);
            var data = '';

            doc.on('data', function(chunk) {
                data += chunk.toString();
            });

            doc.on('end', function() {

                if (file.indexOf('index.js') >= 0 && data.length > 0) {

                    console.log('Writing documentation for', file);
                    var mdtitle = file.replace('index.js', 'README.md');

                    try {
                        fs.writeFileSync(mdtitle, data);
                    } catch (e) {

                        console.error('Could not write MD to file!', e);
                        console.error('JS file:', file);
                        console.error('MD file:', mdtitle);

                        process.exit(1);
                        return;

                    }

                }

                next();

            });

        }, function () {

            console.log('We are done here!');

        });

    });

}
